/* Project 2: 3D Visualization
 by Stejara Dinulescu
 MAT 259A, George Legrady
 
 DESCRIPTION: This is a 3D visualization of check-out counts over time for books whose titles include the terms "generational" or "embodied" and "memory".
 CURRENT STATE: Working in 2D view without PeasyCam in order to get everything situated, then will integrate PeasyCam and system sliders.
 The system iterates through time points of random check-out count data for 500 agents.
 I am developing the visualization and movement, and then will bring in the mySQL query code.
 */

import peasy.*;
PeasyCam cam;

Table table;

int NUM_AGENTS = 100; // change this to number of results that come from query.
int startYear = 2010;
int endYear = 2021;
int TIME_POINTS = 365 * (endYear - startYear); // how many days in this period
int time_index = 0;
float system_rate = 5; // this will turn into a slider
int step_index = 0;
int NUM_STEPS = 10;

Entry[] entries = new Entry[NUM_AGENTS];

void setup() {
  size(1300, 1300, P3D);
  background(0);
  colorMode(HSB, 255);

  //cam = new PeasyCam(this, 0, 0, 0, 50);

  //table = loadTable("Data.csv", "header");
  for (int i = 0; i < NUM_AGENTS; i++) { // loop through row id
    String title = "Agent_" + i; // table.getString(i, "Title");
    Entry e = new Entry(title, i);
    float avg = 0.0;
    for (int j = 0; j < TIME_POINTS; j++) {
      // // get the count and store it in the array at the specified index
      // String colName = "Count_" + j;
      // e.storeTimePoints(j, table.getInt(TIME_POINTS, colName) );
      // // Figure out how to store the count in the table,
      // // this will change based on that

      // at the moment, generate random data
      int rcount = int( random(0, 500) );
      avg += rcount;
      e.storeTimePoints(j, rcount);
    }
    avg = map(avg/TIME_POINTS, 0, 500, 1, 20);
    e.size = avg;
    entries[i] = e; 
  }

  // Everything should be stored now from the table
  println("done creating entries and storing values");
  println("time_points = " + TIME_POINTS);
}

void draw() {
  background(0);
  if (time_index >= 0 && time_index < TIME_POINTS) {
    int true_count = 0;
    for (int i = 0; i < NUM_AGENTS; i++) {
      if (entries[i].updatePosition(time_index)) { true_count++; } 
      entries[i].drawAgent();
      //entries[i].drawAgentHistory(time_index);
    }
    //println("true count = " + true_count);
    if (true_count >= NUM_AGENTS) {
      time_index += 1;
      true_count = 0;
      println("next time point: ", time_index);
      delay(500);
    }
  }
}

void keyPressed() {
  if (key == ' ') {
  }  // reset the system --> TODO
}
